<template>
<transition name="modal-fade">
   <div class="modal-backdrop" @click="close">
    <div class="modal" @click.stop>
      <div class="modal-container modal-image bg-black">
        <img :src="'http://localhost:3500/api/srcImage/' + image._id" alt="" class="image-in-modal">
      </div>
      <div class="line"></div>
      <div class="modal-container commentaires">
        <div class="user-poster-container">
        <img v-if="image.user.profil_picture == null" src="../assets/images/default_avatar.jpg" alt="" class="img-profil-modal">
        <h1 class="user-poster-username">{{image.user.name}}</h1>
        </div>
        <div v-for="commentaire in commentaires" :key="commentaire" class="commentaire-container">
            <p class="user-commentaire">{{commentaire.user.name}}</p>
            <div v-if="currentUserId === commentaire.user._id">
              <i class="fa-solid fa-trash" @click="deleteCom(commentaire._id)"></i>
            </div>
            <p class="p-commentaire">{{commentaire.commentaire}}</p>
        </div>
        <div class="bottom-page">
          <LikeImage 
            :image="image"
            :idx="idx"
            @incrementLike="(like) => incrementLike(image, like)"
            @decrementLike="(like)=> decrementLike(image, like)"
          />
          <i class="fa-regular fa-comment icon-svg"></i>
          <CountLike
            :image="image"
          />
          <CommentaireExist
            :image="image"
          />
        </div>
      </div>
    </div>
  </div>
</transition>
</template>

<script>

import axios from 'axios'
// import CommentaireExist from './CommentaireExist.vue'
import LikeImage from './LikeImage.vue';
import CommentaireExist from './CommentaireExist.vue';
import CountLike from './CountLike.vue';
import { useStore } from '@/store/store';
import { mapState } from 'pinia';




export default {

    name: 'modalImage',

    props: {
      image: Object,
      idx: Number
    },

    components: {
    CountLike,
    LikeImage,
    CommentaireExist,
},

    data(){
      return{
        currentUserId: localStorage.getItem('user'),
      }
    },

    computed: {
        ...mapState(useStore, ['commentaires']),
    },

  mounted(){
    const store = useStore()
    store.fetchCommentaires(this.image._id);
  },

    methods: {
      close() {
        this.$emit('close');
      },
      deleteCom(commId){
        console.log(this.image._id)
          axios.delete('http://localhost:3500/api/commentaire/delete/' + commId + '/' + this.image._id)
          .then(response => {
                // IMPORTANT CA 
              this.commentaires.splice(this.commentaires.map(comm => comm._id).indexOf(response.data._id), 1)
            })
            .catch(err => {
                console.log(err)
            })
        },
        incrementLike(image, like){
            image.likes.push(like)
        },
        decrementLike(image, like){
            
            const findIndex = image.likes.findIndex(likeId =>{
                return like === likeId
            })

            image.likes.splice(findIndex, 1)
        }
    }
}
</script>

<style scoped>
.bg-black{
  background-color: black;
}
.modal-backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba(0, 0, 0, 0.15);
    display: flex;
    justify-content: center;
    align-items: center;
  }

  .modal {
    background: #FFFFFF;
    overflow-x: auto;
    display: flex;
    flex-direction: row;
    height: 80%;
    width: 70%;
  }
  .modal-container{
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    width: 60%;
    height: 100%;
  }
  .commentaires{
    width: 40%;
    height: 100%;
    display: flex;
    justify-content: flex-start;
    flex-direction: column;
  }
  .user-commentaire{
    margin: 0 5px 0 0;
    font-weight: 600;
  }
  .commentaire-container{
    display: flex;
    width: 100%;
    justify-content: flex-start;
    margin: 1rem 0 0 0; 
  }
  .p-commentaire{
    margin: 0;
  }
  .user-poster-container{
    display: flex;
    flex-direction: row;
    height: 10%;
    width: 100%;
  }
  .user-poster-username{
    font-size: 1rem;
    align-self: center;
  }
  .line{
    width: 1px;
    height: 100%;
    background: black;
  }
  .image-in-modal{
    width: 100%;
    height: 70%;
    object-fit: cover;
  }

  .modal-fade-enter,
  .modal-fade-leave-to {
    opacity: 0;
  }

  .modal-fade-enter-active,
  .modal-fade-leave-active {
    transition: opacity .5s ease;
  }

  .img-profil-modal{
        border-radius: 50%;
        margin: 10px;
        width: 3rem;
        height: 3rem;
  }
  .bottom-page{
    width: 100%;
    margin-top: auto;
  }

  @media only screen and (max-width: 600px){
    .modal{
      flex-direction: column;
    }
  }

</style>